//==========load sound=====================
import ddf.minim.*;
import ddf.minim.effects.*;

Minim minim;
AudioPlayer groove;
BandPass bpf;


//=========textureDiagonal()===============
int tileCount = 20;
int myRandomSeed = 0;
int myStrokeCap = ROUND;



//==========pulsing circles================
int numCircles = 100; 
float rad = 50f;
float diameter;
float angle = 0.0f;
float speed = 0.05;
int alphaValue =0;

float[] xPositions = new float[numCircles];
float[] yPositions = new float[numCircles];



//=========time inspector==================
int myFrameRate=60;
float showTime;


//========banner============================
boolean banner = false;
PImage photo;





void setup() {
  
  background(255);
  size(1000, 1000);
  frameRate(myFrameRate);
  smooth();

  //==========pulsing circle array===========

  for (int j=0;j< numCircles; j++) {

    xPositions[j] = random(0, width);
    yPositions[j] = random(0, height);
  }

  //==========load image=====================
  photo = loadImage("crimewave.jpg");



  //==========load sound=====================
  minim = new Minim(this);

  groove = minim.loadFile("crimewave.mp3");
  groove.play();
  bpf = new BandPass(440, 220, groove.sampleRate());
  groove.addEffect(bpf);
}




void draw() {


  showTime = showTime+1;
  println(showTime);

  if (showTime > 0*myFrameRate && showTime <2*myFrameRate) {
    banner = true;
    if (banner == true) {
      banner();
    }
  }



  else if (showTime == 2*myFrameRate) {
    background(255);
   texture_diagonal();
  }
  else if (showTime == 4*myFrameRate) {
   texture_diagonal2();
  } 

  //==========first wave===========================
  else if (showTime > 8*myFrameRate && showTime <= 18*myFrameRate) {
    numCircles=10;
    pulsingCircle();
  }  

  //==========second wave===========================
  else if (showTime >= 18*myFrameRate && showTime < 26*myFrameRate) {
    numCircles=35;
    pulsingCircle();
  }  

  //==========third wave===========================
  else if (showTime >= 26*myFrameRate && showTime < 34*myFrameRate) {

    numCircles=50;
    pulsingCircle();
  }  
  //==========fourth wave===========================
  else if (showTime >=34*myFrameRate && showTime < 49*myFrameRate) {

    numCircles=65;
    pulsingCircle2();
  }  

  //==========fiveth wave===========================
  else if (showTime >=49*myFrameRate && showTime < 60*myFrameRate) {

    numCircles=90;
    pulsingCircle2();
  }  
  
}

void banner() {

  noStroke(); 
  fill(255); 
  image(photo, 0, height/2-200);
}

void texture_diagonal() {

  stroke(0);
  smooth();
  noFill();
  strokeCap(myStrokeCap);

  randomSeed(myRandomSeed);

  for (int gridY=0; gridY<tileCount; gridY++) {
    for (int gridX=0; gridX<tileCount; gridX++) {

      int posX = width/tileCount*gridX;
      int posY = height/tileCount*gridY;

      int diagonalDirection = (int) random(0, 2);

      if (diagonalDirection == 0) {
        strokeWeight(5);
        line(posX, posY, posX+width/tileCount, posY+height/tileCount);
      }
      if (diagonalDirection == 1) {
        strokeWeight(11);
        line(posX, posY+width/tileCount, posX+height/tileCount, posY);
      }
    }
  }
}

void texture_diagonal2() {


  stroke(255, 205, 0);
  smooth();
  noFill();
  strokeCap(myStrokeCap);

  randomSeed(myRandomSeed);

  for (int gridY=0; gridY<tileCount; gridY++) {
    for (int gridX=0; gridX<tileCount; gridX++) {

      int posX = width/tileCount*gridX;
      int posY = height/tileCount*gridY;

      int diagonalDirection = (int) random(0, 2);

      if (diagonalDirection == 0) {
        strokeWeight(4);
        line(posX+width/tileCount, posY, posX, posY+height/tileCount);
      }
      if (diagonalDirection == 1) {
        strokeWeight(8);
        line(posX, posY, posX+height/tileCount, posY+width/tileCount);
      }
    }
  }
}


void pulsingCircle() {

  angle += speed;

  diameter = sin(angle)*30;

  for (int j=0; j< numCircles; j++) {
    stroke(255, 205, 0, 125);
    fill(255, 0, 0, 125);
    ellipse(xPositions[j], yPositions[j], diameter, diameter);
  }
}

void pulsingCircle2() {

  angle += speed;

  diameter = sin(angle)*45;

  for (int j=0; j< numCircles; j++) {
    stroke(255, 0, 0, 125);
    fill(0, 0, 0, 125);
    ellipse(xPositions[j], yPositions[j], diameter, diameter);
  }
}



void stop() {

  minim.stop();
  super.stop();
}

void keyPressed() {
  if (key=='s') {
    save("crimeWave_texture.jpg");
  }
}

